
import javabook.*;

class Frase
{
   /***********************
      Datos Miembro
   ***********************/

   private MainWindow  ventanaPrincipal;
   private InputBox    cuadroEntrada;
   private OutputBox   cuadroSalida;
   private ResponseBox cuadroRespuesta;
   private MessageBox  cuadroMensaje;

   private String fraseEntrada,
                  fraseSalida;

   /***********************
      Constructor
   ***********************/

   public Frase()
   {
      ventanaPrincipal   = new MainWindow("Frases con palabras invertidas");
      cuadroSalida       = new OutputBox(ventanaPrincipal);
      cuadroRespuesta    = new ResponseBox(ventanaPrincipal);
      cuadroEntrada      = new InputBox(ventanaPrincipal);
      cuadroMensaje      = new MessageBox(ventanaPrincipal);


      ventanaPrincipal.show();
      cuadroSalida.show();
   }

   /***********************
      Mtodos Pblicos
   ***********************/

   public void empezar ()
   {
      int respuesta;
      respuesta = cuadroRespuesta.prompt("Quieres obtener la frase correcta?");
      while (respuesta == cuadroRespuesta.YES)
      {
         leerFrase();
         obtenerFraseSalida();
         mostrarResultado();
         respuesta = cuadroRespuesta.prompt("Quieres obtener ms frases?");
      }
   }

   /***********************
      Mtodos Privados
   ***********************/

   private void leerFrase()
   {
      fraseEntrada = cuadroEntrada.getString("Introducir la frase original: ");
      while(!fraseEsCorrecta())
      {
		    cuadroMensaje.show("La frase contiene caracteres numricos. Repetir. ");
            fraseEntrada = cuadroEntrada.getString("La frase original es: ");
      }
   }

   private boolean fraseEsCorrecta ()
   {
      boolean esCorrecta = true;
      int i = 0;
      int longitud = fraseEntrada.length();
      while (i < longitud && esCorrecta)
      {
		  char car = fraseEntrada.charAt(i);
		  if (car >= '0' && car <= '9')
		  {
			 esCorrecta = false;
		  }
		  i++;
  	  }
	  return esCorrecta;
   }

   private void obtenerFraseSalida()
   {
      int i = 0;
      int longitud = fraseEntrada.length();
      int inicio, fin;
      String palabraEntrada, palabraSalida;
      fraseSalida = "";

      while (i < longitud)
      {
		  inicio = i;

		  while (i < longitud && fraseEntrada.charAt(i) != ' ')
          {
			  i++;
		  }

          fin = i;
          palabraEntrada = fraseEntrada.substring(inicio,fin);
          cuadroSalida.printLine(palabraEntrada);
          palabraSalida = recomponerPalabra(palabraEntrada);
          fraseSalida = fraseSalida + palabraSalida + " ";
          i++;
      }
   }

   private String recomponerPalabra(String palabra)
   {
	   StringBuffer palabraInver = new StringBuffer(palabra);
	   return palabraInver.reverse().toString();
   }

   private void mostrarResultado()
   {
      cuadroSalida.skipLine(3);
      cuadroSalida.printLine("Frase de Partida:");
      cuadroSalida.printLine("               " + fraseEntrada);
      cuadroSalida.skipLine(1);
      cuadroSalida.printLine("Frase de Salida:");
      cuadroSalida.printLine("               " + fraseSalida);
   }
}
